/*
   MDCrack.c
   MD5 collision bruteforcer

   *******************************************
   derived from the RSA Data
   Security, Inc. MD5 Message-Digest Algorithm
   *******************************************

   Try every passwords up to 8 chars length.
   Useful to crack authentication protocols using paswords MD5 hash.
   Use it only to validate a new password choice/something like that 
   and nothing illegal.

   Author: Gregory Duchemin 
   Email : c3rb3r@hotmail.com 
   www : http://mdcrack.multimania.com
   Credit to Simeon Pilgrim for his fast MD5 algorithm.

   Version 0.1   Date: 21 Feb 2001.
   Version 0.2   Date: 03 Mar 2001.
   Version 0.3   Date: 05 Mar 2001.
   Version 0.4   Date: 07 Mar 2001.
   Version 0.5   Date: 08 Mar 2001.
   Version 0.6   Date: 14 Mar 2001.
   Version 0.7   Date: 18 Mar 2001.
   Version 0.8   Date: 01 Apr 2001.
   Version 0.8.5 Date: 03 Apr 2001.
   Version 0.9   Date: 06 Apr 2001.
   Version 0.9.5 Date: 08 May 2001.
*/


#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/timeb.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>
#include <sys/stat.h>
#include "generic.h"
#include "version.h"
#ifdef NCURSES
#include <ncurses.h>
#endif


#ifndef RESUME_FILE
#define RESUME_FILE "/tmp/.mdcrack.resume"
#endif
#ifndef BENCH_HASH
#define BENCH_HASH "ffffffffffffffffffffffffffffffff"
#endif
#ifndef ALFA
#define ALFA "abcdefghijklmnopqrstuvwxyz0123456789ABCDEFGHIJKLMNOPQRSTUWXYZ"
#endif
#ifndef BLOCKSIZE
#define BLOCKSIZE 50
#endif


#ifndef NCURSES
#define printw printf
#endif



#define swap32(x) (((x & 0x000000ff)<<24) +\
                   ((x & 0x0000ff00)<<16) +\
                   ((x & 0x00ff0000)>>16) +\
                   ((x & 0xff000000)>>24))


void hashprint(unsigned int *);

unsigned int count;
unsigned long count2;
unsigned int verbosity=0;
unsigned int benchmode=0;
unsigned int duration=0;
unsigned int custom=0;
unsigned int all=0;
unsigned int ender=0;
unsigned int beginer=0;
unsigned int hwrite=0;
unsigned int hread=0;
unsigned int fastwrite=0;
unsigned int fast=0;
unsigned int fasta, fastb, fastc, fastd;

int counter=0;
FILE *desw;


long elapsed;
long elapsed_u;
char target[33];
char *filename;
char *alfa;
char *test;
char *total;
extern int optind;
extern char *optarg;
unsigned int tail;
long start;
long start_u;
char *begin;
char *end;
unsigned int working[4];
unsigned int result2[4], digest2[4];


#ifdef ISBIG_ENDIAN
unsigned int x1[14];
#else
unsigned int* x1;
#endif






/* SIGINT handler */


void handle()
{
 FILE *des;
 struct timeval ft;
 float diff;
 unsigned int size,i,j;
 struct stat *secure;
 int key;



 gettimeofday(&ft, NULL);
 elapsed=(ft.tv_sec)-start;
 elapsed_u=(ft.tv_usec)-start_u;


 alarm(0);


#ifdef NCURSES
 if (verbosity)
   {
     if (hread)
       {
	 mvwprintw(stdscr, 10, 59, " <--  precomputed string.");
	 mvwprintw(stdscr, 10, 25, "%s", total);
	 if (verbosity==2)
	   {
	     mvwprintw(stdscr, 11, 59, " <--  precomputed hash.");
	     hashprintw(result2, 11, 25);
	     attrset(COLOR_PAIR(1)|A_BOLD);
	     hashprintw(digest2, 12, 25);
	     mvwprintw(stdscr, 12, 59, " <--  reference.");
	     attrset(COLOR_PAIR(1));
	     mvwprintw(stdscr, 13, 59, " ");
	   }
	 refresh();
       }
     else
       { 
	 mvwprintw(stdscr, 8, 25, "%s <-- string.", total);
	 
	 if (verbosity==2)
	   {
	     mvwprintw(stdscr, 9, 59, " <-- hash.");
	     hashprintw(result2, 9, 25);
	     attrset(COLOR_PAIR(1)|A_BOLD);
	     hashprintw(digest2, 10, 25);
	     mvwprintw(stdscr, 10, 59, " <-- reference.");
	     attrset(COLOR_PAIR(1));
	     mvwprintw(stdscr, 11, 59, " ");
	   }
	 refresh();
       }
   }
 
 mdmesg(32, NULL);
 attrset(COLOR_PAIR(2));
 refresh();
#endif 
 
 size=strlen(total);
 if (total[size-1]==(char)0x80)
   total[size-1]=0x00;
 
 if (hwrite)
   {
     mdmesg(14, filename);
     fclose(desw);
   }
 
 if (!benchmode)
   {
     secure=(struct stat*)malloc(1*sizeof(struct stat));
     if (!secure)
       {
	 mdmesg(7, NULL);
	 exit(0);
       }
     key=lstat(RESUME_FILE, secure);
     if (S_ISLNK(secure->st_mode))
       mdmesg(15, NULL);
     else
       {
	 des=fopen(RESUME_FILE, "w+");
	 if (des)
	   {
	     if ((!hwrite) && (!hread)) strcpy(filename, "none");
	     
	     fprintf(des, "%s %s %d %d %s %d %d %s %d %d %d", target, total, verbosity, custom, alfa+1, hwrite, hread, filename, fastwrite, beginer, ender);
	     if (!beginer)
	       fprintf(des, " none");
	     else
	       fprintf(des, " %s", begin);
	     if (!ender)
	       fprintf(des, " none");
	     else
	       fprintf(des, " %s", end);
	     
	     fclose(des);
	   }
	 printw("\nGenerating resume file "RESUME_FILE"\n");
       } 
   }
 
 if ((elapsed_u<10000) && (!elapsed))
   {
     
     if (benchmode)
       printw("\nBenchmark result."); 
     
     
     printw("\n");
     for (i=0; i<40; i++)
       {
	 
#ifdef NCURSES 
	 if (((i<14)||(i>25))&& (i!=11)&&(i!=28))
	   attrset(COLOR_PAIR(1));
	 else
	   attrset(COLOR_PAIR(1)|A_BOLD);
#endif
	 
	 printw(SYMBOL);
       }
     printw("\n");
     
     printw("Current string --> ");
     
#ifdef NCURSES 
     attrset(COLOR_PAIR(1)|A_REVERSE);
     refresh();
#endif
     
     printw("%s\n", total);
     
#ifdef NCURSES 
     attrset(COLOR_PAIR(2));
     refresh();
#endif
     
     
#ifdef NCURSES 
     attrset(COLOR_PAIR(2)|A_REVERSE);
     refresh();
#endif
     printw("%s\n", total); 
     mdmesg(29, NULL);
     
   }
 else
   {
     
     if (elapsed_u < 0)
       {
	 elapsed_u=1000000+elapsed_u;
         if (elapsed>0) elapsed--;
       }
     
     diff=(float)elapsed+((float)elapsed_u/1000000);
     
     
     if (benchmode)
       printw("\nBenchmark result."); 
     
     if (!hread)
       {
	 printw("\n");
	 for (i=0; i<40; i++)
	   {
	     
#ifdef NCURSES 
	     if (((i<14)||(i>25))&&(i!=11)&&(i!=28))
	       attrset(COLOR_PAIR(1));
	     else
	       attrset(COLOR_PAIR(1)|A_BOLD);
#endif
	     printw(SYMBOL);
	   }
	 printw("\n");
	 
	 printw("Current string --> ");
	 
#ifdef NCURSES 
	 attrset(COLOR_PAIR(1)|A_REVERSE);
	 refresh();
#endif
	 printw("%s\n", total);
#ifdef NCURSES 
	 attrset(COLOR_PAIR(2));
	 refresh();
#endif
	 printw("Collision(s) tested : %u in %lu second(s), %lu millisec, %lu microsec.\nAverage of %.1f hashes/sec.\n\n", count, elapsed, (elapsed_u/1000), (elapsed_u%1000),(float) ((float)count/diff));
       }
     else
       {
	 printw("\n");
	 for (i=0; i<40; i++)
	   {
#ifdef NCURSES 
	     if (((i<14)||(i>25))&&(i!=11)&&(i!=28))
	       attrset(COLOR_PAIR(1));
	     else
	       attrset(COLOR_PAIR(1)|A_BOLD);
#endif
	     printw(SYMBOL);
	   }
	 printw("\nCollision(s) tested : %u in %lu second(s), %lu millisec, %lu microsec.\nAverage of %.1f hashes/sec.\n\n", count, elapsed, (elapsed_u/1000), (elapsed_u%1000),(float) ((float)count/diff));
       }
     fflush(stdout);
   }
 
#ifdef NCURSES
 refresh();
#else
 fflush(stdout);
#endif
 

doexit();
}






/* Usage */



void usage(void)
{

#ifdef NCURSES
  attrset(COLOR_PAIR(1));
#endif

  logow();
  
  
  printw("\nMDCrack version 0.9.5\n( Bruteforce your MD5 hashes )\nUsage: MDCrack [-h] [-v | -V] [-d] [-W file -R file -F] [-b randomizer] [-e randomizer] [-t secs] [-a] [-s string] [digest] \n-h : (h)elp, this text\n-v : set (v)erbose mode\n-V : more (V)erbose\n-d : (d)elete any resume-file \n-W : file where to (W)rite all computed hashes\n-R : file where to (R)ead computed hashes\n-F : (F)ast write (Hashes file is no longer human-readable)\n-b : string to concatenate (b)efore passwords.\n-e : string to concatenate at passwords (e)nd.\n-t : Benchmark mode (t)imer, compute during secs seconds\n-a : find (a)ll collisions (won't stop to the first found)\n-s : feed a custom charset (s)tring\nNo option at all will force mdcrack to resume a previously stopped session\n\nAuthor: Gregory Duchemin\nEmail: c3rb3r@hotmail.com\nWWW: http://mdcrack.multimania.com \nCredit to Simeon Pilgrim for his fast MD5 algorithm\n\n*******************************************\nderived from the RSA Data Security Inc.\nMD5 Message-Digest Algorithm\n*******************************************\n\n");
 
  

#ifdef NCURSES
  refresh();
#endif
}





/* Resume file cleaner */



int cleanup(reference)
	char *reference;
{

   if (remove(reference))
     return(1); 
return(0);
}






/* main */


int main (argc, argv)
     int argc;
     char *argv[];
{
  int i;
  int found;
  FILE *des1;
  char c;
  char resume[256];
  char value[33];
  char feed[500];
 

  bzero(resume, 256);
  bzero(value, 33);
  alfa=(char *)malloc(64);
  strcpy(alfa+1, ALFA);
  *alfa='\0';


#ifdef NCURSES

 

 


 initscr();
 cbreak();
 noecho();
 start_color();
 clear();
 
 init_pair(1, COLOR_GREEN, COLOR_BLACK);
 init_pair(2, COLOR_WHITE, COLOR_BLACK);
 init_pair(3, COLOR_RED, COLOR_BLACK);
 init_pair(4, COLOR_YELLOW, COLOR_BLACK);
 attrset(COLOR_PAIR(1) | A_BOLD);


 scrollok(stdscr, TRUE);      
 syncok(stdscr, TRUE);
 leaveok(stdscr, TRUE);

#endif



 mdmesg(33, NULL);
 

 begin=(char *)malloc(256);
 if (!begin)
   {
     mdmesg(7, NULL);
     doexit();
   }
 bzero(begin, 256);
 end=(char *)malloc(256);
 if (!end)
   {
     mdmesg(7, NULL);
     doexit();
   }
 
 filename=(char *) malloc(512);
 if (!filename)
   {
     mdmesg(7, NULL);
     doexit();
   }
 
 if (argc==1) 
   {
     if ((des1=fopen(RESUME_FILE, "r")) == NULL )
       {
	 usage();
	 mdmesg(2, NULL);
	 doexit(); 
       }
     
     bzero(end, 256);
     fscanf(des1, "%32s %s %d %d %s %d %d %s %d %d %d %s %s", value, resume, &verbosity, &custom, alfa+1, &hwrite, &hread, filename, &fastwrite, &beginer, &ender, begin, end);
     *(alfa)=0x00;
     
     mdmesg(16, NULL); 
     printw("       { \n         Hash: \"%s\"\n         Last try: \"%s\"\n         Verbosity: %d\n         Read: %d\n         Write: %d\n         File: %s\n         Fastmode: %d\n         Charset: %s\n         Begining string: %s\n         Ending string: %s\n       }\n\n", value, resume, verbosity, hread, hwrite, filename, fastwrite, alfa+1, begin, end);
     
#ifdef NCURSES
     refresh(); 
#endif
     
     fflush(stdout); 
     
     if (hwrite)
       {
	 desw=fopen(filename, "a");
	 if (!desw)
	   {
	     usage();
	     mdmesg(3, NULL);
	     doexit(); 
	   }
       }
     if (hread)
       {
	 desw=fopen(filename, "r");
	 if (!desw)
	   {
	     usage();
	     mdmesg(4, NULL);
	     doexit(); 
	   }
       }
     sleep(2);

     for (i=4;i<20;i++)
       mvwprintw(stdscr, i, 0,"                                                                                                                                                                                                                                       ");

     mvwprintw(stdscr, 3, 0, " ");

#ifdef NCURSES
     refresh();
#endif
     
     
   }
 else
   {
     
     while(1)
       {
	 c=getopt(argc, argv, "hvVdas:t:b:e:W:R:F");
	 if (c==-1)
	   break;
	 
	 switch(c)
	   {
	   case 't':
	     benchmode=1;
	     duration=atoi(optarg); 
	     break;
	     
	   case 'h':
	     usage(); 
	     doexit();
	     break;
	     
	     
	   case 'd':
	     if (cleanup(RESUME_FILE)) 
	       {
		 usage();
		 mdmesg(5, NULL);
		 doexit();
	       }
	     else
	       {
		 mdmesg(17, NULL);
		 doexit();
	       }
	     break;
	     
	   case 'v':
	     if (!verbosity)
	       verbosity=1;
	     break;
	     
	   case 'V':
	     verbosity=2;
	     break;
	     
	   case 'b':
	     if ((strlen(optarg)+strlen(end)+9)>56)
	       {
		 mdmesg(34, NULL);
		 doexit();
	       }     
#ifdef ISBIG_ENDIAN 
	     begin=(char *)malloc(strlen(optarg)+1);
#else
	     realloc(begin, strlen(optarg)+1); 
#endif
	     if (!begin)
	       {
		 mdmesg(7, NULL);
		 doexit();
	       }
	     strcpy(begin, optarg);
	     beginer=1;
	     break;
	     
	   case 'e':
	     if ((strlen(begin)+strlen(optarg)+9)>56)
	       {
		 mdmesg(34, NULL);
		 doexit();
	       }
#ifdef ISBIG_ENDIAN      
	     end=(char *)malloc(strlen(optarg)+1);
#else
	     realloc(end, strlen(optarg)+1);
#endif
	     
	     if (!end)
	       {
		 mdmesg(7, NULL);
		 doexit();
	       }
	     strcpy(end, optarg);
	     ender=1;
	     break;
	     
	   case 'a':
	     all=1;
	     break;
	     
	   case 's':
	     custom=1;
	     charset_sort(optarg);
	     
#ifdef ISBIG_ENDIAN
	     alfa=(char *)malloc(strlen(optarg)+2);  
#else
	     realloc(alfa, strlen(optarg)+2);
#endif

	     strcpy(alfa+1, optarg); 
	     *(alfa)='\0';
	     break;
	     
	   case 'W':
	     if (hread)
	       {
		 usage();
		 mdmesg(9, NULL);
		 doexit(); 
	       }
	     if ((desw=fopen(optarg, "w+")) == NULL)
	       {
		 usage();
		 mdmesg(10, NULL);
		 doexit(); 
	       }
	     strcpy(filename, optarg);
	     hwrite=1;
	     break;
	     
	     
	   case 'R':
	     if (hwrite)
	       {
		 usage();
		 mdmesg(9, NULL);
		 doexit(); 
	       }
	     
	     if ((desw=fopen(optarg, "r")) == NULL )
	       {
		 usage();
		 mdmesg(6, NULL);
		 doexit(); 
	       }
	     strcpy(filename, optarg);
	     hread=1;
	     break;
	     
	     
	   case 'F':
	     fastwrite=1;
	     break;
	     
	   case '?':
	     usage();
	     exit(0);
	     break;
	     
	   default:
	     usage();
	     break;
	   }
       }
   }
 
 
 if ((optind+1<=argc) || (argc==1) || (benchmode))
   {
     
     if (argc==1)
       strcpy(feed, value);
     else
       {
	 if (benchmode)
	   strcpy(feed, BENCH_HASH);
	 else
	   strcpy(feed, *(argv+optind));
       }
     
    

     if (strlen(feed) != 32)
       {
	 mdmesg(1, NULL); 
	 doexit();
       }
     
     
     if (custom) 
       mdmesg(18, alfa+1);
     else if (!hread)
       mdmesg(19, alfa+1);
     
     
     if (hread)
       {    
	 if (!(found=crack_read(feed, resume)))
	     mdmesg(0, NULL);
	    
	 doexit();
       }
     
     
     if (verbosity)
       {
	 if (!(found=crack_verbose(feed, resume)))
	     mdmesg(0, NULL);
	     
	 doexit();
       }
     
     if (hwrite)
       {
	 if (!(found=crack_rw(feed, resume)))
	     mdmesg(0, NULL);
      
	 doexit();
       }

     if ((strlen(begin)+strlen(end)+9)>28)
       {
	 if (!(found=crack_long(feed, resume)))
	   mdmesg(0, NULL);
	 doexit();
       }
     
      if ((strlen(begin)+strlen(end)+9)>12)
       {
	 if (!(found=crack_middle(feed, resume)))
	   mdmesg(0, NULL);
	 doexit();
       }

     if (ender)
       {
	 if (!(found=crack_end(feed, resume)))
	     mdmesg(0, NULL);
	   
	 doexit();
       }
     
     if (!(found=crack(feed, resume)))
	 mdmesg(0, NULL);  

     doexit();
   }
 
 usage();
 doexit();

}






/* ncursized exit */


doexit()
{

#ifdef NCURSES
  attrset(COLOR_PAIR(2));
  mdmesg(30, NULL);
  attrset(COLOR_PAIR(2)|A_BLINK);
  
  mdmesg(35, NULL);
  
  refresh();
  cbreak();
  noecho();
  getch();
  endwin();
#endif
  
  exit(0);
  
}









/* passwords <= 12 bytes (begin) */
/* OK */


int crack(input, resume)
     char *input;
     char *resume;
{
  char conv[]="0123456789abcdef";
  register char *a,*b,*c,*d,*e,*f,*g,*h;
  unsigned int result2[4];
  char *copy;
  register unsigned int MAX=(unsigned int) alfa+strlen(alfa+1)+1;
  register unsigned int MIN=(unsigned int) alfa+1; 
  unsigned char i,j; 
  unsigned int offset=0;
  char *mov;
  char digest[16];
  unsigned int digest2[4];
  struct timeval *tp;
  unsigned int size=12;
  register unsigned int len, len_begin=0;
  unsigned int flag1, flag2, flag3, flag4;
  

 
  tp=(struct timeval *)malloc(sizeof(struct timeval)); 
  if (!tp)
   {
     mdmesg(7, NULL);
     doexit();
   }
  bzero(digest, 16);
  mov=digest;
  copy=input;
  strncpy(target, input, 32);
  
  a=b=c=d=e=f=g=alfa;
  
  if (resume[0])
    {
      
      if (beginer) offset=len_begin=strlen(begin);
      len=strlen(resume)-len_begin;
      
      
      for (i=0; i<len; i++)
	for (j=1;j<=strlen(alfa+1);j++)
	  if (resume[len_begin+i]==alfa[j])
	    { 
	      if (!i)   h=alfa+j;
	      if (i==1) g=alfa+j;
	      if (i==2) f=alfa+j;
	      if (i==3) e=alfa+j;
	      if (i==4) d=alfa+j;
	      if (i==5) c=alfa+j;
	      if (i==6) b=alfa+j;
	      if (i==7) a=alfa+j;
            }
      len+=offset;
    }
  else
    {
      h=(char *)MIN;
      if (beginer) offset=len_begin=strlen(begin);
      len=1+offset;
    }
  
  flag1=flag2=flag3=flag4=0;
  if (len_begin>3) flag1=1;
  if (len_begin>2)flag2=1;
  if (len_begin>1) flag3=1;
  if (len_begin) flag4=1;
  
  up2low(input);
  ascii2bin(copy, conv, mov);
  Decode(digest2, mov, 16);  
  
  digest2[0] -= 0x67452301;
  digest2[1] -= 0xefcdab89;  
  digest2[2] -= 0x98badcfe;  
  digest2[3] -= 0x10325476;
  
  
  
  test=(char *)malloc(size);
  if (!test)
    {
      mdmesg(7, NULL);
      doexit();
    }
  total=test;
  bzero(test, size);
  
  if (beginer) 
    {
      memcpy(test, begin, len_begin);
      test=test+len_begin;
    }
  
  *test=*h;
  
  
  
  tail=(unsigned int) len << 3;
  total[len]=0x80;
  printw("\nPassword size: %u \n", len);
  
  
#ifdef NCURSES
  refresh();
#else
  fflush(stdout);
#endif
  
  
#ifndef ISBIG_ENDIAN  
  x1=(unsigned int *)total;
#endif
  
  md5_reverse(working, digest2, x1);
  
  
  signal(SIGINT, handle);
  if (benchmode)
    {
      alarm(duration);
      signal(SIGALRM, handle);
    }
  
  
  gettimeofday(tp, NULL);
  start=tp->tv_sec;
  start_u=tp->tv_usec;
  
  
  for(;a<(char *)MAX;a++)
    {
      *(test+7)=*a;
      for(;b<(char *)MAX;b++)
	{
	  *(test+6)=*b;
	  for(;c<(char *)MAX;c++)
	    {
	      *(test+5)=*c;
	      for(;d<(char *)MAX;d++)
		{
		  *(test+4)=*d;
		  for(;e<(char *)MAX;e++)
		    {
		      *(test+3)=*e;
		      for(;f<(char *)MAX;f++)
			{
			  *(test+2)=*f;
			  for(;g<(char *)MAX;g++)
			    {
			      *(test+1)=*g;
			      for(;h<(char *)MAX;h++)
				{
				  *test=*h;
				  
				  count++;	  

#ifdef ISBIG_ENDIAN
 				Decode(x1, total, 12);
#endif

				  
				  if (MD5Transform())
				    {
				      
				      if (!stats(total,len))
					mdmesg(8, NULL);
				      
				      if (!all)
					return(1);	
				      total[len]=0x80;
				    }
				  
				  
				  if (flag1) fast=0;
				  if (len_begin>6)
				    md5_reverse(working, digest2, x1);
				}
			      
			      
                              h=(char *)MIN;
			      if (flag2) fast=0;
			      
			      if (len<2+offset) 
				{
				  len++;
				  total[len]=0x80;
				  tail=(unsigned int) len << 3;
				  fast=0;				  
				  printw("\nPassword size: %u \n", len);

#ifdef NCURSES
				  refresh();
#else
				  fflush(stdout);
#endif
				  
				}
			      if (len_begin>5)
				md5_reverse(working, digest2, x1);     
			      
			    }
			  
			  g=(char *)MIN;
			  
			  
			  if (flag3) fast=0;
			  
			  if (len<3+offset) 
			    {
			      len++;
			      tail=(unsigned int) len << 3;
			      total[len]=0x80;
			      fast=0;
			      printw("\nPassword size: %u \n", len);

#ifdef NCURSES
			      refresh();
#else		      
			      fflush(stdout);
#endif	
		    }

			   if (len_begin>4)
				md5_reverse(working, digest2, x1);
			}
		      
		      f=(char *)MIN;
		      
		      if (flag4) fast=0;
		      
		      if (len<4+offset) 
			{
			  len++;
			  tail=(unsigned int) len << 3;
			  total[len]=0x80;
			  fast=0;
			  printw("\nPassword size: %u \n", len);

#ifdef NCURSES
			  refresh();
#else		 
			  fflush(stdout);
#endif	
		}
		      
		      if (len_begin>3)

			md5_reverse(working, digest2, x1);


		    }
		  e=(char *)MIN;
		  
		  fast=0;
		  
		  if (len<5+offset) 
		    {
		      len++;
		      tail=(unsigned int) len << 3;
		      total[len]=0x80;
		      printw("\nPassword size: %u \n", len);

#ifdef NCURSES
		      refresh();
#else	      
		      fflush(stdout);
#endif	
		    }
		  
		  if (len_begin>2)
		
		    md5_reverse(working, digest2, x1);
		  
		}

              d=(char *)MIN;
	      
	      if (len<6+offset) 
		{
		  len++;
		  tail=(unsigned int) len << 3;
		  total[len]=0x80;
		  printw("\nPassword size: %u \n", len);

#ifdef NCURSES
		  refresh();
#else	
		  fflush(stdout);
#endif	
	}
	      
	      if (len_begin>1)
		md5_reverse(working, digest2, x1);
	   
	    }

          c=(char *)MIN;
	  
	  if (len<7+offset) 
	    {
	      len++;
	      tail=(unsigned int) len << 3;
	      total[len]=0x80;	      
	      printw("\nPassword size: %u \n", len);

#ifdef NCURSES
	      refresh();
#else	     
	      fflush(stdout);
#endif	
    }
	  
	  if (len_begin)
	    md5_reverse(working, digest2, x1);
	  
	}

      b=(char *)MIN;
      
      if (len<8+offset) 
	{
	  len++;
	  tail=(unsigned int) len << 3;
	  total[len]=0x80;
	  md5_reverse(working, digest2, x1);
	  printw("\nPassword size: %u \n", len);

#ifdef NCURSES
	  refresh();
#else
	  fflush(stdout);
#endif
	}
      
      if (len_begin)
	md5_reverse(working, digest2, x1);
    }
  
  return(0);
}









/* Crack verbosely all size simple/file (end/begin) */
/* OK */





int crack_verbose(input, resume)
     char *input;
     char *resume;
{
  char conv[]="0123456789abcdef";
  register char *a,*b,*c,*d,*e,*f,*g,*h;
  char *copy;
  unsigned int offset=0;
  register int MAX=(unsigned int) alfa+strlen(alfa+1)+1;
  register int MIN=(unsigned int) alfa+1; 
  unsigned char i,j; 
  char *mov;
  char digest[16];
  struct timeval *tp;
  register unsigned int len_begin=0, len_end=0;
  unsigned int len, working[4];
  unsigned int size=56, tail;
  unsigned char byte1, byte2, byte3, byte4;
 


  tp=(struct timeval *)malloc(sizeof(struct timeval)); 
  if (!tp)
   {
     mdmesg(7, NULL);
     exit(0);
   }
  bzero(digest, 16);
  mov=digest;
  copy=input;
  strncpy(target, input, 32);
  
    a=b=c=d=e=f=g=alfa;

   if (resume[0])
    {

     if (beginer) offset=len_begin=strlen(begin);
     if (ender) offset+=len_end=strlen(end);
     len=strlen(resume)-offset;
   

     for (i=0; i<len; i++)
       for (j=1;j<=strlen(alfa+1);j++)
         if (resume[len_begin+i]==alfa[j])
            { 
             if (!i)   h=alfa+j;
             if (i==1) g=alfa+j;
             if (i==2) f=alfa+j;
             if (i==3) e=alfa+j;
             if (i==4) d=alfa+j;
             if (i==5) c=alfa+j;
             if (i==6) b=alfa+j;
             if (i==7) a=alfa+j;
            }
       len+=offset;

    }
  else
    {
      h=(char *)MIN;
      if (beginer) offset=len_begin=strlen(begin);
      if (ender) offset+=len_end=strlen(end);
      len=1+offset;
    }



  up2low(input);
  ascii2bin(copy, conv, mov);
  Decode(digest2, mov, 16);  
  
 

  if (offset+9>56)
    {
      mdmesg(11, NULL);
      doexit();
    }

  test=(char *)malloc(size);
  if (!test)
   {
     mdmesg(7, NULL);
     doexit();
   }

  total=(char *)malloc(size);
  if (!total)
   {
     mdmesg(7, NULL);
     doexit();
   }

  bzero(test, size);
  bzero(total, size);
  mov=test;

  if (beginer) 
    {
      memcpy(test, begin, len_begin);
      test=test+len_begin;
    }

 
  tail=len<<3;
  total[len]=0x80;
  
#ifdef NCURSES
  refresh();
#else
  fflush(stdout);
#endif
  
 if (hwrite){
  if (fastwrite)
    fwrite(YES, sizeof(char), 1, desw);
  else
    fwrite(NO, sizeof(char), 1, desw);

  fwrite("\0", sizeof(char), 1, desw); 
  fwrite((char *) &len, sizeof(char), 1, desw);}

 if (benchmode)
    {
     alarm(duration);
     signal(SIGALRM, handle);
    }

  signal(SIGINT, handle);
  gettimeofday(tp, NULL);
  start=tp->tv_sec;
  start_u=tp->tv_usec;

  
  for(;a<(char *)MAX;a++)
    {
       *(test+7)=*a;
      for(;b<(char *)MAX;b++)
	{
	  *(test+6)=*b;
	  for(;c<(char *)MAX;c++)
	    {
	      *(test+5)=*c;
	      for(;d<(char *)MAX;d++)
		{
		  *(test+4)=*d;
		  for(;e<(char *)MAX;e++)
		    {
		      *(test+3)=*e;
		      for(;f<(char *)MAX;f++)
			{
			  *(test+2)=*f;
			  for(;g<(char *)MAX;g++)
			    {
			      *(test+1)=*g;
			      for(;h<(char *)MAX;h++)
				{
				  *test=*h;
			
				  memcpy(total, mov, len-len_end); 
				  memcpy(total+len-len_end, end, len_end);
				  
								 
				  total[len]=0x80;
                                  MD5compact(result2, total, tail);
				  total[len]=0x00;
				
				  if (hwrite)
				  if (!fastwrite)
				  {
                                   fwrite(total, sizeof(char), strlen(total), desw);
                                   for (i=0; i<4; i++)
                                     {
	                              byte1=(unsigned char) ((result2[i])>>24);
	                              byte2=(unsigned char) ((result2[i]&0x00ff0000)>>16);
	                              byte3=(unsigned char) ((result2[i]&0x0000ff00)>>8);
	                              byte4=(unsigned char) ((result2[i])&0x000000ff);
                                      
    				      fprintf (desw,"%02x%02x%02x%02x",byte4, byte3, byte2, byte1);
				     }
                                   fwrite("\0\n", sizeof(char), 2, desw);
				  }
				  else 
				  { 
				  fwrite(total, sizeof(char), strlen(total), desw);
				  fwrite(result2, sizeof(unsigned int), 4, desw);
				  }
                                
#ifdef NCURSES
				  mvwprintw(stdscr, 8, 25, "%s <-- string.", total);
				  refresh();
#else
				  printw("\n%s <-- string.\n", total);
                                  fflush(stdout);
#endif
				  if (verbosity==2)
				  {
                                 
#ifdef NCURSES
				    mvwprintw(stdscr, 9, 59, " <-- hash.");
				    hashprintw(result2, 9, 25);
				    refresh();
#else
				    hashprint(result2);
				    printf(" <-- hash.\n");  
				    fflush(stdout);
#endif
                                  

#ifdef NCURSES
				    attrset(COLOR_PAIR(1)|A_BOLD);
				    mvwprintw(stdscr, 10, 59, " <-- reference.");
				    hashprintw(digest2, 10, 25);
				    attrset(COLOR_PAIR(1));
				    refresh();
#else
				    hashprint(digest2);
				    printw(" <-- reference.\n\n");
				    fflush(stdout);
#endif

	       
				  }
#ifdef NCURSES
				  refresh();
#else
                                  fflush(stdout);
#endif
				
                                  count++;
				 
                                  if ((*digest2==*result2)&&(*(digest2+1)==*(result2+1))&&(*(digest2+2)==*(result2+2))&&(*(digest2+3)==*(result2+3)))
				    {
				     total[len]=0x00;
				     if (!stats(total, len))
				       mdmesg(8, NULL);
					
                                     
                                      if (!all)
					return(1);
				       total[len]=0x80;
				      
				    }                                 
				}
                              h=(char *)MIN;
			      if (len<2+offset) 
				{
				   len++;
				   if (hwrite){
		     
				     fwrite("\0", sizeof(char), 1, desw); 
				     fwrite((char *) &len, sizeof(char), 1, desw);}
				   tail=len<<3;
		
				}
			    }
                           g=(char *)MIN;
			   if (len<3+offset) 
			     {
			       	len++;
				if (hwrite){
				fwrite("\0", sizeof(char), 1, desw); 
				fwrite((char *) &len, sizeof(char), 1, desw);}
			        tail=len<<3;

			     }
			}
                       f=(char *)MIN;
		       if (len<4+offset) 
			 {
			    len++;
			    if (hwrite){
			    fwrite("\0", sizeof(char), 1, desw); 
			    fwrite((char *) &len, sizeof(char), 1, desw);}
			    tail=len<<3;

			 
			 }
		    }
                   e=(char *)MIN;
		   if (len<5+offset) 
		     {
		       	len++;
			if (hwrite){
		        fwrite("\0", sizeof(char), 1, desw); 
			fwrite((char *) &len, sizeof(char), 1, desw);}
		        tail=len<<3;
		
		     }
		}
              d=(char *)MIN;
              if (len<6+offset) 
		{
		   len++;
		   if (hwrite){
		   fwrite("\0", sizeof(char), 1, desw); 
		   fwrite((char *) &len, sizeof(char), 1, desw);}
		   tail=len<<3;

		}
	    }
          c=(char *)MIN;
	  if (len<7+offset) 
	    {
	      len++;
	      if (hwrite){
	      fwrite("\0", sizeof(char), 1, desw); 
	      fwrite((char *) &len, sizeof(char), 1, desw);}
	      tail=len<<3;

	   
	    }
	}
      b=(char *)MIN;
      if (len<8+offset) 
	{
	   len++;
	   if (hwrite){
	   fwrite("\0", sizeof(char), 1, desw); 
	   fwrite((char *) &len, sizeof(char), 1, desw);}
	   tail=len<<3;
	 
	}
    }

  return(0);

}







/* passwords <= 28 bytes (end/begin) */
/* OK */



int crack_middle(input, resume)
     char *input;
     char *resume;
{
  char conv[]="0123456789abcdef";
  register char *a,*b,*c,*d,*e,*f,*g,*h;
  unsigned int result2[4];
  char *copy;
  unsigned int offset=0;
  register int MAX=(unsigned int) alfa+strlen(alfa+1)+1;
  register int MIN=(unsigned int) alfa+1; 
  unsigned char i,j; 
  char *mov2;
  char digest[16];
  unsigned int digest2[4];
  struct timeval *tp;
  register unsigned int len_begin=0, len_end=0;
  unsigned int len, working[4];
  unsigned int size=28, tail;


  tp=(struct timeval *)malloc(sizeof(struct timeval)); 
  if (!tp)
   {
     mdmesg(7, NULL);
     exit(0);
   }
  bzero(digest, 16);
  mov2=digest;
  copy=input;
  strncpy(target, input, 32);
  
    a=b=c=d=e=f=g=alfa;

   if (resume[0])
    {

     if (beginer) offset=len_begin=strlen(begin);
     if (ender) offset+=len_end=strlen(end);
     len=strlen(resume)-offset;
   

     for (i=0; i<len; i++)
       for (j=1;j<=strlen(alfa+1);j++)
         if (resume[len_begin+i]==alfa[j])
            { 
             if (!i)   h=alfa+j;
             if (i==1) g=alfa+j;
             if (i==2) f=alfa+j;
             if (i==3) e=alfa+j;
             if (i==4) d=alfa+j;
             if (i==5) c=alfa+j;
             if (i==6) b=alfa+j;
             if (i==7) a=alfa+j;
            }
       len+=offset;

    }
  else
    {
      h=(char *)MIN;
      if (beginer) offset=len_begin=strlen(begin);
      if (ender) offset+=len_end=strlen(end);
      len=1+offset;
    }



  up2low(input);
  ascii2bin(copy, conv, mov2);
  Decode(digest2, mov2, 16);  
  
 


  test=(char *)malloc(size);
  if (!test)
   {
     mdmesg(7, NULL);
     doexit();
   }


  bzero(test, size);
  total=test;
  mov2=total+len_begin+1;


  if (beginer) 
    {
      memcpy(test, begin, len_begin);
      test=test+len_begin;
    }

 
  tail=len<<3;
  total[len]=0x80;
  
 
  printw("\nPassword size: %u \n", len);

#ifdef NCURSES
  refresh();
#endif
  fflush(stdout);


 if (benchmode)
    {
     alarm(duration);
     signal(SIGALRM, handle);
    }


  signal(SIGINT, handle);
  gettimeofday(tp, NULL);
  start=tp->tv_sec;
  start_u=tp->tv_usec;

  
  for(;a<(char *)MAX;a++)
    {
       *(test+7)=*a;
      for(;b<(char *)MAX;b++)
	{
	  *(test+6)=*b;
	  for(;c<(char *)MAX;c++)
	    {
	      *(test+5)=*c;
	      for(;d<(char *)MAX;d++)
		{
		  *(test+4)=*d;
		  for(;e<(char *)MAX;e++)
		    {
		      *(test+3)=*e;
		      for(;f<(char *)MAX;f++)
			{
			  *(test+2)=*f;
			  for(;g<(char *)MAX;g++)
			    {
			      *(test+1)=*g;
			      for(;h<(char *)MAX;h++)
				{
				  *test=*h;
			

				  if (ender)
				    strncpy(mov2, end, len_end);
				  total[len]=0x80;				
                                  MD5intermediate(result2, total, tail);
			       
		
                                  count++;
				 
                                  if ((*digest2==*result2)&&(*(digest2+1)==*(result2+1))&&(*(digest2+2)==*(result2+2))&&(*(digest2+3)==*(result2+3)))
				    {
				     total[len]=0x00;
				     if (!stats(total, len))
				       mdmesg(8, NULL);
					
                                     
                                      if (!all)
					return(1);
				       total[len]=0x80;
				      
				    }                                 
				}
                              h=(char *)MIN;
			      if (len<2+offset) 
				{
				  len++;
				  mov2++;
				  total[len]=0x80;
			     
				  tail=len<<3;
				  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
				  refresh();
#else
				  fflush(stdout);
#endif	
				}
			    }
			  g=(char *)MIN;
			  if (len<3+offset) 
			    {
			      len++;
			      mov2++;
			      total[len]=0x80;
			    
			      tail=len<<3;
			      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
			      refresh();
#else
			      fflush(stdout);
#endif	
			    }
			}
		      f=(char *)MIN;
		      if (len<4+offset) 
			{
			  len++;
			  mov2++;
			  total[len]=0x80;
			 
			  tail=len<<3;
			  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
			  refresh();
#else
			  fflush(stdout);
#endif	  
			}
		    }
		  e=(char *)MIN;
		  if (len<5+offset) 
		    {
		      len++;
		      mov2++;
		      total[len]=0x80;
		    
		      tail=len<<3;
		      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
		      refresh();
#else
		      fflush(stdout);
#endif	      
		    }
		}
              d=(char *)MIN;
              if (len<6+offset) 
		{
		  len++;
		  mov2++;
		  total[len]=0x80;
		
		  tail=len<<3;
		  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
		  refresh();
#else
		  fflush(stdout);
#endif	  
		}
	    }
          c=(char *)MIN;
	  if (len<7+offset) 
	    {
	      len++;
	      mov2++;
	      total[len]=0x80;
	     
	      tail=len<<3;
	      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
	      refresh();
#else
	      fflush(stdout);
#endif      
	    }
	}
      b=(char *)MIN;
      if (len<8+offset) 
	{
	  len++;
	  mov2++;
	  total[len]=0x80;
	
	  tail=len<<3;
	  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
	  refresh();
#else
	  fflush(stdout);
#endif
	  
	}
    }
  
  return(0);
  
}







/* passwords <= 56 bytes (end/begin) */
/* OK */


int crack_long(input, resume)
     char *input;
     char *resume;
{
  char conv[]="0123456789abcdef";
  register char *a,*b,*c,*d,*e,*f,*g,*h;
  unsigned int result2[4];
  char *copy;
  unsigned int offset=0;
  register int MAX=(unsigned int) alfa+strlen(alfa+1)+1;
  register int MIN=(unsigned int) alfa+1; 
  unsigned char i,j; 
  char *mov2;
  char digest[16];
  unsigned int digest2[4];
  struct timeval *tp;
  register unsigned int len_begin=0, len_end=0;
  unsigned int len, working[4];
  unsigned int size=56, tail;



  tp=(struct timeval *)malloc(sizeof(struct timeval)); 
  if (!tp)
   {
     mdmesg(7, NULL);
     exit(0);
   }
  bzero(digest, 16);
  mov2=digest;
  copy=input;
  strncpy(target, input, 32);
  
    a=b=c=d=e=f=g=alfa;

   if (resume[0])
    {

     if (beginer) offset=len_begin=strlen(begin);
     if (ender) offset+=len_end=strlen(end);
     len=strlen(resume)-offset;
   

     for (i=0; i<len; i++)
       for (j=1;j<=strlen(alfa+1);j++)
         if (resume[len_begin+i]==alfa[j])
            { 
             if (!i)   h=alfa+j;
             if (i==1) g=alfa+j;
             if (i==2) f=alfa+j;
             if (i==3) e=alfa+j;
             if (i==4) d=alfa+j;
             if (i==5) c=alfa+j;
             if (i==6) b=alfa+j;
             if (i==7) a=alfa+j;
            }
       len+=offset;

    }
  else
    {
      h=(char *)MIN;
      if (beginer) offset=len_begin=strlen(begin);
      if (ender) offset+=len_end=strlen(end);
      len=1+offset;
    }



  up2low(input);
  ascii2bin(copy, conv, mov2);
  Decode(digest2, mov2, 16);  
  
 
  test=(char *)malloc(size);
  if (!test)
   {
     mdmesg(7, NULL);
     doexit();
   }

  bzero(test, size);
  total=test;

  if (beginer) 
    {
      memcpy(test, begin, len_begin);
      test=test+len_begin;
    }

 
  tail=len<<3;
  total[len]=0x80;
  mov2=total+len_begin+1;


  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
  refresh();
#endif
  fflush(stdout);

 if (benchmode)
    {
     alarm(duration);
     signal(SIGALRM, handle);
    }

  signal(SIGINT, handle);
  gettimeofday(tp, NULL);
  start=tp->tv_sec;
  start_u=tp->tv_usec;

  
  for(;a<(char *)MAX;a++)
    {
       *(test+7)=*a;
      for(;b<(char *)MAX;b++)
	{
	  *(test+6)=*b;
	  for(;c<(char *)MAX;c++)
	    {
	      *(test+5)=*c;
	      for(;d<(char *)MAX;d++)
		{
		  *(test+4)=*d;
		  for(;e<(char *)MAX;e++)
		    {
		      *(test+3)=*e;
		      for(;f<(char *)MAX;f++)
			{
			  *(test+2)=*f;
			  for(;g<(char *)MAX;g++)
			    {
			      *(test+1)=*g;
			      for(;h<(char *)MAX;h++)
				{
				  *test=*h;
			
				  if (ender)
				    strncpy(mov2, end, len_end);  	
				  total[len]=0x80;
                                  MD5compact(result2, total, tail);
			       
		
                                  count++;
				 
                                  if ((*digest2==*result2)&&(*(digest2+1)==*(result2+1))&&(*(digest2+2)==*(result2+2))&&(*(digest2+3)==*(result2+3)))
				    {
				     total[len]=0x00;
				     if (!stats(total, len))
				       mdmesg(8, NULL);
					
                                     
                                      if (!all)
					return(1);
				       total[len]=0x80;
				      
				    }                                 
				}
                              h=(char *)MIN;
			      if (len<2+offset) 
				{
				  len++;
				  mov2++;
				  total[len]=0x80;
				  tail=len<<3;

				  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
				  refresh();
#else
				  fflush(stdout);
#endif	
				}
			    }
			  g=(char *)MIN;
			  if (len<3+offset) 
			    {
			      len++;
			      mov2++;
			      total[len]=0x80;
			      tail=len<<3;

			      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
			      refresh();
#else
			      fflush(stdout);
#endif	
			    }
			}
		      f=(char *)MIN;
		      if (len<4+offset) 
			{
			  len++;
			  mov2++;
			  total[len]=0x80;
			  tail=len<<3;

			  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
			  refresh();
#else
			  fflush(stdout);
#endif	  
			}
		    }
		  e=(char *)MIN;
		  if (len<5+offset) 
		    {
		      len++;
		      mov2++;
		      total[len]=0x80;
		      tail=len<<3;

		      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
		      refresh();
#else
		      fflush(stdout);
#endif	      
		    }
		}
              d=(char *)MIN;
              if (len<6+offset) 
		{
		  len++;
		  mov2++;
		  total[len]=0x80;
		  tail=len<<3;

		  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
		  refresh();
#else
		  fflush(stdout);
#endif	  
		}
	    }
          c=(char *)MIN;
	  if (len<7+offset) 
	    {
	      len++;
	      mov2++;
	      total[len]=0x80;
	      tail=len<<3;

	      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
	      refresh();
#else
	      fflush(stdout);
#endif      
	    }
	}
      b=(char *)MIN;
      if (len<8+offset) 
	{
	  len++;
	  mov2++;
	  total[len]=0x80;
	  tail=len<<3;

	  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
	  refresh();
#else
	  fflush(stdout);
#endif
	  
	}
    }
  
  return(0);  
}









/* passwords <= 12 bytes (end/begin) */
/* OK */


int crack_end(input, resume)
     char *input;
     char *resume;
{
  char conv[]="0123456789abcdef";
  register char *a,*b,*c,*d,*e,*f,*g,*h;
  unsigned int result2[4];
  char *copy;
  unsigned int MAX=(unsigned int) alfa+strlen(alfa+1)+1;
  unsigned int MIN=(unsigned int) alfa+1; 
  unsigned char i,j; 
  unsigned int offset=0;
  char *mov2;
  char digest[16];
  unsigned int digest2[4];
  struct timeval *tp;
  register unsigned int len;
  unsigned int size=12;
  register unsigned int len_begin=0, len_end=0;


  tp=(struct timeval *)malloc(sizeof(struct timeval)); 
  if (!tp)
   {
     mdmesg(7, NULL);
     exit(0);
   }
  bzero(digest, 16);
  mov2=digest;
  copy=input;
  strncpy(target, input, 32);
  
    a=b=c=d=e=f=g=alfa;


 if (resume[0])
    {

     offset=len_end=strlen(end);
     if (beginer) offset+=len_begin=strlen(begin);
   
     len=strlen(resume)-offset;
   

     for (i=0; i<len; i++)
       for (j=1;j<=strlen(alfa+1);j++)
         if (resume[len_begin+i]==alfa[j])
            { 
             if (!i)   h=alfa+j;
             if (i==1) g=alfa+j;
             if (i==2) f=alfa+j;
             if (i==3) e=alfa+j;
             if (i==4) d=alfa+j;
             if (i==5) c=alfa+j;
             if (i==6) b=alfa+j;
             if (i==7) a=alfa+j;
            }
       len+=offset;

    }
  else
    {
      h=(char *)MIN;
      
      offset=len_end=strlen(end); 
      if (beginer) offset+=len_begin=strlen(begin);
      len=1+offset;
    }


  up2low(input);
  ascii2bin(copy, conv, mov2);
  Decode(digest2, mov2, 16);  
  
  digest2[0] -= 0x67452301;
  digest2[1] -= 0xefcdab89;  
  digest2[2] -= 0x98badcfe;  
  digest2[3] -= 0x10325476;


  test=(char *)malloc(size);
  if (!test)
   {
     mdmesg(7, NULL);
     doexit();
   }



  bzero(test, size);
  mov2=test+len_begin+1;
  total=test;

  if (beginer) 
   {
    memcpy(test, begin, len_begin);
    test=test+len_begin;
   }

#ifndef ISBIG_ENDIAN
  x1 = (unsigned int *)total;
#endif
 
  md5_reverse(working, digest2, x1);			  



  signal(SIGINT, handle);
  if (benchmode)
    {
     alarm(duration);
     signal(SIGALRM, handle);
    }


  tail=(unsigned int) len << 3;
  printw("\nPassword size: %u \n", len);

#ifdef NCURSES
  refresh();
#else
  fflush(stdout);
#endif


  gettimeofday(tp, NULL);
  start=tp->tv_sec;
  start_u=tp->tv_usec;


  for(;a<(char *)MAX;a++)
    {
       *(test+7)=*a;
      for(;b<(char *)MAX;b++)
	{
	  *(test+6)=*b;
	  for(;c<(char *)MAX;c++)
	    {
	      *(test+5)=*c;
	      for(;d<(char *)MAX;d++)
		{
		  *(test+4)=*d;
		  for(;e<(char *)MAX;e++)
		    {
		      *(test+3)=*e;
		      for(;f<(char *)MAX;f++)
			{
			  *(test+2)=*f;
			  for(;g<(char *)MAX;g++)
			    {
			      *(test+1)=*g;
			      for(;h<(char *)MAX;h++)
				{

				  *test=*h;
				  memcpy(mov2, end, len_end);
				  count++;


#ifdef ISBIG_ENDIAN
                                Decode(x1, total, 12);
#endif			

				  if (MD5Transform())
				   {
				    if (!stats(total, len))
				      mdmesg(8, NULL);
				              
                                      if (!all)
				         return(1);
				      total[len]=0x80;
				   }
				  if (len_begin>3) fast=0;
				  if (len_begin>6)
				    md5_reverse(working, digest2, x1);

				}
			      
                              h=(char *)MIN;
			      if (len_begin>2) fast=0;
			      if (len<2+offset) 
				{
				  fast=0;
				  len++;
				  total[len]=0x80;
				  mov2++;
				  tail=(unsigned int) len << 3;
				  
				  md5_reverse(working, digest2, x1);
				  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
				  refresh();
#endif
				  fflush(stdout);
				}
			      if (len_begin>5)
				md5_reverse(working, digest2, x1);

			    }
			  
                           g=(char *)MIN;
			   if (len_begin>1) fast=0;
			   if (len<3+offset) 
			     {
			      fast=0;
			      len++;
			      total[len]=0x80;
			      mov2++;
			      tail=(unsigned int) len << 3;
  
			      md5_reverse(working, digest2, x1);
			      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
			      refresh();
#endif
			      fflush(stdout);
			     }
			   if (len_begin>4)
			     md5_reverse(working, digest2, x1);

			}
		       
                       f=(char *)MIN;
		       if (len_begin) fast=0;
		       if (len<4+offset) 
			 {
			  fast=0;
			  len++;
			  total[len]=0x80;
			  mov2++;
			  tail=(unsigned int) len << 3;
		       
			  md5_reverse(working, digest2, x1);
			  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
			  refresh();
#endif
			  fflush(stdout);
			 }
		       if (len_begin>3)
			 md5_reverse(working, digest2, x1);
		    }
		   
                   e=(char *)MIN;
		   fast=0;
		   if (len<5+offset) 
		     {
		      len++;
		      total[len]=0x80;
		      mov2++;
		      tail=(unsigned int) len << 3;
		      
		      md5_reverse(working, digest2, x1);
		      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
		      refresh();
#endif
		      fflush(stdout);
		     }
		   if (len_begin>2)
		     md5_reverse(working, digest2, x1);
		}
	     
              d=(char *)MIN;
      
	      if (len<6+offset) 
		{
		 len++;
		 total[len]=0x80;
		 mov2++;
		 tail=(unsigned int) len << 3;
		 
		 md5_reverse(working, digest2, x1);
		 printw("\nPassword size: %u \n", len);
#ifdef NCURSES
		 refresh();
#endif
		 fflush(stdout);
		}
	      if (len_begin>1)
		md5_reverse(working, digest2, x1);
	    }
	  
          c=(char *)MIN;
	
          if (len<7+offset) 
	    {
	     len++;
	     total[len]=0x80;
	     mov2++;
	     tail=(unsigned int) len << 3;
	    
	     md5_reverse(working, digest2, x1);
	     printw("\nPassword size: %u \n", len);
#ifdef NCURSES
	     refresh();
#endif
	     fflush(stdout);
	    }

	  if (len_begin)
	    md5_reverse(working, digest2, x1);
	}
     
      b=(char *)MIN;
     
      if (len<8+offset) 
	{
	  len++;
	  total[len]=0x80;
	  mov2++;
	  tail=(unsigned int) len << 3;
	 
	  md5_reverse(working, digest2, x1);
	  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
	  refresh();
#endif
	  fflush(stdout);
	}
      if (len_begin)
	md5_reverse(working, digest2, x1);
    }

  return(0);
}











/* crack in file */



int crack_rw(input, resume)
     char *input;
     char *resume;
{
  char conv[]="0123456789abcdef";
  register char *a,*b,*c,*d,*e,*f,*g,*h;
  unsigned int result2[4];
  char *copy;
  register int MAX=(unsigned int) alfa+strlen(alfa+1)+1;
  register int MIN=(unsigned int) alfa+1; 
  unsigned char i,j; 
  unsigned int offset=0, len_begin=0, len_end=0;
  char *mov2;
  char digest[16];
  unsigned int digest2[4];
  struct timeval *tp;
  char *bufferw;
  unsigned char len;
  unsigned char byte1, byte2, byte3, byte4;
  unsigned int size=56, amount, tail;
  float diff;
  char *bufferr;
  
 
  tp=(struct timeval *)malloc(sizeof(struct timeval));
  if (!tp)
   {
     mdmesg(7, NULL);
     doexit();
   } 
  bzero(digest, 16);
  mov2=digest;
  copy=input;
  strncpy(target, input, 32);
  
    a=b=c=d=e=f=g=alfa;




 if (resume[0])
    {
     
     if (ender)  offset=len_end=strlen(end);
     if (beginer) offset+=len_begin=strlen(begin);
   
     len=strlen(resume)-offset;
   

     for (i=0; i<len; i++)
       for (j=1;j<=strlen(alfa+1);j++)
         if (resume[len_begin+i]==alfa[j])
            { 
             if (!i)   h=alfa+j;
             if (i==1) g=alfa+j;
             if (i==2) f=alfa+j;
             if (i==3) e=alfa+j;
             if (i==4) d=alfa+j;
             if (i==5) c=alfa+j;
             if (i==6) b=alfa+j;
             if (i==7) a=alfa+j;
            }
       len+=offset;

    }
  else
    {
      h=(char *)MIN;
 
      if (beginer) offset=len_begin=strlen(begin);
      if (ender) offset+=len_end=strlen(end);     
      len=1+offset;
    }


  up2low(input);
  ascii2bin(copy, conv, mov2);
  Decode(digest2, mov2, 16);  


 
  test=(char *)malloc(size);
  if (!test)
   {
     mdmesg(7, NULL);
     doexit();
   }

  total=test;
  bzero(test, size);
  
 if (beginer) 
   {
    memcpy(test, begin, len_begin);
    test=test+len_begin;
   }
  

  bufferr=(char *)malloc((BLOCKSIZE/2)*1024*1024);
  if (!bufferr)
    {
      mdmesg(7, NULL);
      doexit();
    }
  if (fastwrite)
    mdmesg(23, NULL);
  else
    mdmesg(24, NULL);


  mdmesg(25, NULL);
  mdmesg(20, BLOCKSIZE);



  fflush(NULL);
  setvbuf(desw, NULL, _IONBF, 0);

  gettimeofday(tp, NULL);
  start=tp->tv_sec;
  start_u=tp->tv_usec;
  amount=fwrite(bufferr, sizeof(char), BLOCKSIZE*1024*1024, desw);
  gettimeofday(tp, NULL);
  elapsed=tp->tv_sec-start;
  elapsed_u=tp->tv_usec-start_u;
 

  if (elapsed_u < 0)
    {
     elapsed_u=1000000+elapsed_u;
     if (elapsed>0) elapsed--;
     }
     diff=(float)elapsed+((float) elapsed_u/(float)1000000);
     diff=((float) (amount/(1024*1024)) /diff);
     printw(" %.1f MB/sec.", diff);
    
#ifdef NCURSES
     refresh();
#else
     fflush(stdout);
#endif
    
  fseek(desw, 0, SEEK_SET);
  mdmesg(21, (BLOCKSIZE/2));


#ifdef ISBIG_ENDIAN
  bufferr=(char *)malloc((BLOCKSIZE/2)*1024*1024);
#else
  realloc(bufferr, (BLOCKSIZE/2)*1024*1024);
#endif

  
  fflush(NULL);
  setvbuf(desw, bufferr, _IOFBF, (BLOCKSIZE/2)*1024*1024); 
  
  signal(SIGINT, handle);
  if (benchmode)
    {
      alarm(duration);
      signal(SIGALRM, handle);
    }
  
  tail=len<<3;
  total[len]=0x80;
  mov2=total+len_begin+1;
  printw("\nPassword size: %u \n", len);

#ifdef NCURSES
  refresh();
#else   
  fflush(stdout);
#endif

  if (fastwrite)
    fwrite(YES, sizeof(char), 1, desw);
  else
    fwrite(NO, sizeof(char), 1, desw);
  
  fwrite("\0", sizeof(char), 1, desw); 
  fwrite((char *) &len, sizeof(char), 1, desw);
  



  gettimeofday(tp, NULL);
  start=tp->tv_sec;
  start_u=tp->tv_usec;


  for(;a<(char *)MAX;a++)
    {
       *(test+7)=*a;
      for(;b<(char *)MAX;b++)
	{
	  *(test+6)=*b;
	  for(;c<(char *)MAX;c++)
	    {
	      *(test+5)=*c;
	      for(;d<(char *)MAX;d++)
		{
		  *(test+4)=*d;
		  for(;e<(char *)MAX;e++)
		    {
		      *(test+3)=*e;
		      for(;f<(char *)MAX;f++)
			{
			  *(test+2)=*f;
			  for(;g<(char *)MAX;g++)
			    {
			      *(test+1)=*g;
			      for(;h<(char *)MAX;h++)
				{
				  *test=*h;
				
				  if (ender)
				    memcpy(mov2, end, len_end);

				  total[len]=0x80;
                                  MD5compact(result2, total, tail);
				  total[len]=0x00;

				  if (!fastwrite)
				    {
				      fwrite(total, sizeof(char), len, desw);
				      
				      for (i=0; i<4; i++)
					{
					  byte1=(char) ((result2[i])>>24);
					  byte2=(char) ((result2[i]&0x00ff0000)>>16);
					  byte3=(char) ((result2[i]&0x0000ff00)>>8);
					  byte4=(char) ((result2[i])&0x000000ff);
					  
					  
					  fprintf(desw, "%02x%02x%02x%02x", byte4, byte3, byte2, byte1);
					  
					}
				      fwrite("\n", sizeof(char), 2, desw);  
				    }
				  else 
				    { 
				      fwrite(total, sizeof(char), len, desw);
				      fwrite(result2, sizeof(unsigned int), 4, desw);
				    }
				  
                                  count++;
				  
				  if ((*digest2==*result2)&&(*(digest2+1)==*(result2+1))&&(*(digest2+2)==*(result2+2))&&(*(digest2+3)==*(result2+3)))
				    {
				      total[len]=0x00;
				      if (!stats(total, len))
					mdmesg(8, NULL);
				      
				      
                                      if (!all)
                                        {
					  fclose(desw);
					  return(1);
					}
				      
				      total[len]=0x80;
				    }
				}
                              h=(char *)MIN;
			      
			      if (len<2+offset)
			      {
			       len++; 
			       tail=len<<3;
                               total[len]=0x80;
			       mov2++;
                               printw("\nPassword size: %u \n", len);
#ifdef NCURSES
			       refresh();
#else
                               fflush(stdout);
#endif
			       fwrite("\0", sizeof(char), 1, desw); 
			       fwrite((char *) &len, sizeof(char), 1, desw);
			      }
			    }
			  g=(char *)MIN;

			  if (len<3+offset) 
			    {
			      len++; 
			      tail=len<<3;
			      total[len]=0x80;
			      mov2++;
			      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
			      refresh();
#else
                              fflush(stdout);
#endif
			      fwrite("\0", sizeof(char), 1, desw); 
			      fwrite((char *) &len, sizeof(char), 1, desw);
			    }
			}
		      f=(char *)MIN;

		      if (len<4+offset) 
			{
			  len++; 
			  tail=len<<3;
			  total[len]=0x80;
			  mov2++;
			  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
			  refresh();
#else
                          fflush(stdout);
#endif
			  fwrite("\0", sizeof(char), 1, desw); 
			  fwrite((char *) &len, sizeof(char), 1, desw);
			}
		    }
		  e=(char *)MIN;

		  if (len<5+offset) 
		    {
		      len++; 
		      tail=len<<3;
		      total[len]=0x80;
		      mov2++;
		      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
		      refresh();
#else
                      fflush(stdout);
#endif
		      fwrite("\0", sizeof(char), 1, desw); 
		      fwrite((char *) &len, sizeof(char), 1, desw);
		    }
		}
              d=(char *)MIN;

	      if (len<6+offset) 
		{
		  len++;
		  tail=len<<3;
		  total[len]=0x80;
		  mov2++;
		  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
		  refresh();
#else
                  fflush(stdout);
#endif
		  fwrite("\0", sizeof(char), 1, desw); 
		  fwrite((char *) &len, sizeof(char), 1, desw);
		}
	    }
          c=(char *)MIN;

	  if (len<7+offset) 
	    {
	      len++; 
	      tail=len<<3;
	      total[len]=0x80;
	      mov2++;
	      printw("\nPassword size: %u \n", len);
#ifdef NCURSES
	      refresh();
#else
              fflush(stdout);
#endif
	      fwrite("\0", sizeof(char), 1, desw); 
	      fwrite((char *) &len, sizeof(char), 1, desw);
	    }
	}
      b=(char *)MIN;

      if (len<8+offset)
	{
	  len++; 
	  tail=len<<3;
	  total[len]=0x80;
	  mov2++;
	  printw("\nPassword size: %u \n", len);
#ifdef NCURSES
	  refresh();
#else
          fflush(stdout);
#endif
	  fwrite("\0", sizeof(char), 1, desw); 
	  fwrite((char *) &len, sizeof(char), 1, desw);
	}
    }
  
  return(0);
}









/* Crack from file */



int crack_read(input, resume)
     char *input;
     char *resume;
{
  char conv[]="0123456789abcdef";
  char *copy;
  char *mov;
  char digest[16];
  unsigned int i;
  struct timeval *tp;
  float diff;
  char hash[16];
  register char *bufferr;
  register char *bufferr2;
  char bufferr3[256];
  register unsigned int amount;
  unsigned int len=0, *bob;
  register unsigned int max,z=0;
  unsigned char length[2]={'1','\n'};
  char flag;
  unsigned char byte1, byte2, byte3, byte4;

  tp=(struct timeval *)malloc(sizeof(struct timeval)); 
  bzero(digest, 16);
  mov=digest;
  copy=input;
  strncpy(target, input, 32);
  

  up2low(input);
  ascii2bin(copy, conv, mov);
  Decode(digest2, mov, 16);  
  
    

   
  total=(char *)malloc(57);
  if (!total)
    {
      mdmesg(7, NULL);
      doexit();
    }

  bufferr=(char *)malloc(BLOCKSIZE*1024*1024);
  if (!bufferr)
    {
      mdmesg(7, NULL);
      doexit();
    }
  
  
  
  mdmesg(26, BLOCKSIZE);
  
  if (fastwrite)
    mdmesg(23, NULL);
  else
    mdmesg(24, NULL);
  
  mdmesg(25, NULL);
  fflush(desw);
  
  setvbuf(desw, NULL, _IONBF, 0);
  
  mdmesg(22, BLOCKSIZE);
  
  gettimeofday(tp, NULL);
  start=tp->tv_sec;
  start_u=tp->tv_usec;
  
  amount=fread(bufferr, sizeof(char), BLOCKSIZE*1024*1024, desw);
  
  gettimeofday(tp, NULL);
  elapsed=tp->tv_sec-start;
  elapsed_u=tp->tv_usec-start_u;

  if (elapsed_u < 0)
    {
      elapsed_u=1000000+elapsed_u;
      if (elapsed>0) elapsed--;
    }
  diff=(float)elapsed+((float) elapsed_u/(float)1000000);
  diff=((float) (amount/(1024*1024)) /diff);
  
  printw(" %.1f MB/sec.\n", diff);
  
#ifdef NCURSES
  refresh();
#else
  fflush(stdout);
#endif


  fseek(desw, 0, SEEK_SET);
  
  signal(SIGINT, handle);

  if (benchmode)
    {
      alarm(duration);
      signal(SIGALRM, handle);
    }
  
  
  fread(&flag, sizeof(char), 1, desw);
  if (fastwrite != (unsigned int)flag-48)
    {
      mdmesg(13, NULL);
      doexit();
    }
  
  
  
  gettimeofday(tp, NULL);
  start=tp->tv_sec;
  start_u=tp->tv_usec;
  
  
  
#ifdef NCURSES
  while((mvwprintw(stdscr, 14+z, 0, "Mounting 1 new block in memory ... ")==OK)&&((amount=fread(bufferr, sizeof(char), BLOCKSIZE*1024*1024, desw)))&&(mvwprintw(stdscr, 14+z++, 37, "done")==OK))
    {
#else
      while((write(1, "\nMounting 1 new block in memory ... ", 36))&&((amount=fread(bufferr, sizeof(char), BLOCKSIZE*1024*1024, desw)))&&(write(1, " done\n", 6)))
	{
#endif
	  
	  bufferr2=bufferr;
	  max=(unsigned int)bufferr+amount;
	  
	  while((unsigned int)bufferr2+len+16 < max)
	    {      
	      
	      
	      if (*bufferr2 == '\0')
		{
		  len= (unsigned char)*(bufferr2+1);
		  bufferr2+=2;
		  
#ifdef NCURSES
		  mvwprintw(stdscr, 14+z++, 0, "Password size: %u", len);
		  refresh();
#else
		  write(1,"\nPassword size: ", 16);
		  printf("%u", len);
		  fflush(stdout);
#endif
		}
	      
	      if (!fastwrite)
		{
		  test=(unsigned char *)(bufferr2+len);
		  
#ifdef NCURSES
		  if (verbosity)
		    {
		      mvwprintw(stdscr, 10, 59, " <--  precomputed string.");
		      mvwprintw(stdscr, 10, 25, "%s", bufferr2);
		      if (verbosity==2)
			{
			  mvwprintw(stdscr, 11, 59, " <--  precomputed hash.");
			  mvwprintw(stdscr, 11, 25, "%s", test);
			  attrset(COLOR_PAIR(1)|A_BOLD);
			  mvwprintw(stdscr, 12, 25, "%s", target);
			  mvwprintw(stdscr, 12, 59, " <--  reference.");
			  attrset(COLOR_PAIR(1));
			  mvwprintw(stdscr, 13, 59, " ");
			}
		      refresh();
		    }
#else
		  if (verbosity)
		    {
		      printw("\n%s <--  precomputed string", bufferr2);
		      if (verbosity==2)
			{
			  printw("\n%s <--  precomputed hash", test);
			  printw("\n%s <--  reference\n", target);
			}
		      fflush(stdout);
		    }
#endif

		  ascii2bin(test, conv, hash);
		  Decode(result2, hash, 16);
		  (unsigned int)bufferr2+=len+35;
		}



	      else



		{
		  bob=(unsigned int*)(bufferr2+len);
		  *result2=*bob;
		  *(result2+1)=*(bob+1);
		  *(result2+2)=*(bob+2);
		  *(result2+3)=*(bob+3);
		  
		  bufferr2+=len+16;

#ifdef NCURSES
		  if (verbosity)
		    {
		      strncpy(bufferr3, bufferr2-len-16, len);
		      bufferr3[len]='\0';
		      strcpy(total, bufferr3);
		      mvwprintw(stdscr, 10, 25, "%s <--  precomputed string.", total);
		      
		      if (verbosity==2)
			{
			  mvwprintw(stdscr, 11, 59, " <--  precomputed hash.");
			  for (i=0; i<4; i++)
			    {
			      byte1=(unsigned char) ((bob[i])>>24);
			      byte2=(unsigned char) ((bob[i]&0x00ff0000)>>16);
			      byte3=(unsigned char) ((bob[i]&0x0000ff00)>>8);
			      byte4=(unsigned char) ((bob[i])&0x000000ff);
			      
			      mvwprintw(stdscr, 11, 25+(8*i), "%02x%02x%02x%02x", byte4, byte3, byte2, byte1);
			    }
			  *result2=*bob;
			  *(result2+1)=*(bob+1);
			  *(result2+2)=*(bob+2);
			  *(result2+3)=*(bob+3);

			  attrset(COLOR_PAIR(1)|A_BOLD);
			  mvwprintw(stdscr, 12, 25, "%s", target);
			  mvwprintw(stdscr, 12, 59, " <--  reference.");
			  attrset(COLOR_PAIR(1));
			  mvwprintw(stdscr, 13, 59, " ");
			}
		      refresh();
		    }
#else
		  if (verbosity)
		    {
		      strncpy(bufferr3, bufferr2-len-16, len);
		      bufferr3[len]='\0';
		      printw("\n%s <--  precomputed string\n", bufferr3);
		      if (verbosity==2)
			{		  
			  for (i=0; i<4; i++)
			    {
			      byte1=(unsigned char) ((result2[i])>>24);
			      byte2=(unsigned char) ((result2[i]&0x00ff0000)>>16);
			      byte3=(unsigned char) ((result2[i]&0x0000ff00)>>8);
			      byte4=(unsigned char) ((result2[i])&0x000000ff);
			      
			      printw("%02x%02x%02x%02x",byte4, byte3, byte2, byte1);
			    }
			  printw(" <--  precomputed hash");
			  printw("\n%s <--  reference\n", target);
			}
		    }
#endif	  
		}
	    
	      
	  count++;
	  if ((*digest2==*result2)&&(*(digest2+1)==*(result2+1))&&(*(digest2+2)==*(result2+2))&&(*(digest2+3)==*(result2+3)))
	    { 
	      if (fastwrite)
		strncpy(total, bufferr2-len-16, len);
	      else
		strcpy(total, (char *)((unsigned int)bufferr2-len-35));
	      if (!stats(total, len))
		mdmesg(8, NULL);
	      
	      
	      if (!all)
		{
		  fclose(desw);
		  return(1);
		}                        
	    }                  
	    }
      if (fastwrite)
	fseek(desw,((unsigned int)bufferr2+16+len-max), SEEK_CUR);
      else
	fseek(desw,((unsigned int)bufferr2+35+len-max), SEEK_CUR); 
	}
  
  printw(" No more byte to read\n");
  
#ifdef NCURSES
  refresh();
#else
  fflush(stdout);
#endif
  
  return(0);
    }
  
  

































